
public class AllarmeStandard {
boolean[] sensori; //Array di booleani, TRUE = sensore acceso, FALSE = sensore spento
	
	//Inizializzo array e setto tutti i sensori a TRUE (accesi)
	public AllarmeStandard() {
		sensori = new boolean[4];
		
		sensori[0] =true;
		sensori[1] =true;
		sensori[2] =true;
		sensori[3] =true;
	}
	
	//Cambio lo stato on/off di un sensore
	public boolean setSensore(int sensore, boolean acceso) {
		if (sensore < 0 || sensore > 3) return false; //Ho solo 4 sensori
		
		if (acceso) {
			if (sensori[sensore]) { //Se  gi TRUE non devo fare nulla
				return false;
			} else { //Altrimenti posso settare a TRUE senza fare altri controlli
				sensori[sensore] = true;
				return true;
			}
		}
		
		//Ora sono nel caso: acceso == false;
		
		//Ottengo gli indici dei 2 sensori vicini
		int nextIndex = sensore+1 == sensori.length ? 0 : sensore+1;
		int prevIndex = (sensore-1+sensori.length) % sensori.length;
		
		//Cambio lo stato solo se i due limitrofi sono accesi e il sensore stesso non  gi spento
		if (sensori[nextIndex] && sensori[prevIndex] && sensori[sensore]) {
			sensori[sensore] = false;
			return true;
		}
		
		return false; //Significa che il sensore era gi spento, ritorno false
		
	}
	
	//restituisce true se il sensore passato come parametro esiste ed  acceso
	public boolean acceso(int sensore) {
		if (sensore < 0 || sensore > 3) return false; //Ho solo 4 sensori
		
		return sensori[sensore];
	}
	
	//Controllo se  presente una situazione di pericolo
	public boolean pericolo() {
		//Controllo i sensori a 2 a 2: se due sensori adiacenti sono spenti, l'OR restituisce false e di conseguenza anche l'AND complessivo
		if ((sensori[0] || sensori[1]) && (sensori[1] || sensori[2]) && (sensori[2] || sensori[3]) && (sensori[3] || sensori[0]))
			return false;
		
		return true;
	}
}
