package main;

public class Allarme {
	/*@ spec_public @*/ boolean[] sensori; //Array di booleani, TRUE = sensore acceso, FALSE = sensore spento
	
	//@ public invariant (sensori[0] || sensori[1]) && (sensori[1] || sensori[2]) && (sensori[2] || sensori[3]) && (sensori[3] || sensori[0]) == true;
	//@ public invariant sensori.length == 4;
	
	//@ ensures sensori[0] == true;
	//@ ensures sensori[1] == true;
	//@ ensures sensori[2] == true;
	//@ ensures sensori[3] == true;
	public Allarme() {
		sensori = new boolean[4];
		
		sensori[0] =true;
		sensori[1] =true;
		sensori[2] =true;
		sensori[3] =true;
	}
	
	//@ requires sensore >= 0 && sensore < 4;
	//@ ensures \result ==> sensori[sensore] == acceso && \old(sensori[sensore]) == !acceso;
	//@ ensures  \old(sensori[sensore]) == acceso ==> \result == false; 
	public boolean setSensore(int sensore, boolean acceso) {
		
		//Codice che garantisce postcondizioni
		if (acceso) {
			if (sensori[sensore]) { //Se  gi TRUE non devo fare nulla
				return false;
			} else { //Altrimenti posso settare a TRUE senza fare altri controlli
				sensori[sensore] = true;
				return true;
			}
		}
		//Ora sono nel caso: acceso == false;
		
		//Ottengo gli indici dei 2 sensori vicini
		int nextIndex = sensore+1 == sensori.length ? 0 : sensore+1;
		int prevIndex = (sensore-1+sensori.length) % sensori.length;
		
		//Cambio lo stato solo se i due limitrofi sono accesi e il sensore stesso non  gi spento
		if (sensori[nextIndex] && sensori[prevIndex] && sensori[sensore]) {
			sensori[sensore] = false;
			return true;
		}
		
		return false; //Significa che il sensore era gi spento, ritorno false
		
	}
	
	//@ requires sensore >= 0 && sensore < 4;
	//@ ensures \result == sensori[sensore];
	public boolean acceso(int sensore) {
		
		return sensori[sensore];
	}
	
	//Controllo se  presente una situazione di pericolo
	public boolean pericolo() {
		//Controllo i sensori a 2 a 2: se due sensori adiacenti sono spenti, l'OR restituisce false e di conseguenza anche l'AND complessivo
		if ((sensori[0] || sensori[1]) && (sensori[1] || sensori[2]) && (sensori[2] || sensori[3]) && (sensori[3] || sensori[0]))
			return false;
		
		return true;
	}
}
