package Allarme;

public class Allarme {
	/*@spec_public @*/ boolean[] sensori;

	
	//@ public invariant (\num_of int y; y>=0 && y<4; sensori[y]==true)>=2;
	//@ public invariant (\forall int y; y>0 && y<3; (sensori[y]==false)==>sensori[y -1]==true && sensori[y+1]==true);
	//@ public invariant sensori[0]==false==>sensori[1]==true && sensori[3]==true;
	//@ public invariant sensori[3]==false==>sensori[2]==true && sensori[0]==true;
	
	
	public Allarme() {
		sensori = new boolean[4];
		for (int i = 0; i < 4; i++)
			sensori[i] = true;
	}

	
	
	//@ requires sensore>=0 && sensore<4;
	//@ ensures (\old(sensori[sensore])==true && acceso==true)==>\result==false;
	//@ ensures (\old(sensori[sensore])==false && acceso==false)==>\result==false;
	//@ ensures (\old(sensori[sensore])==false && acceso==true)==>\result==true && sensori[sensore]==true; 
	// ensures (\old(sensori[sensore])==true && acceso==false)==>\result==true && sensori[sensore]==false; Questa invece
	//non  sempre vera, in quanto viene spento solo se ci  possibile (ovvero i due adiacenti sono accesi)
	
	public boolean setSensore(int sensore, boolean acceso) {
		// mi serve per sapere se posso spegnere il sensore
		int sensoreprecedente, sensoresuccessivo;
		if (sensore == 0)
			sensoreprecedente = 3;
		else
			sensoreprecedente = sensore - 1;

		if (sensore == 3)
			sensoresuccessivo = 0;
		else
			sensoresuccessivo = sensore + 1;

		// se accesso==true e il sensore  gi acceso
		// oppure se accesso==false e il sensore  gi spento
		// non fare nulla
		if ((acceso && sensori[sensore]) || (!acceso && !sensori[sensore]))
			return false;
		//se mettessi return true mi darebbe errore

		// se acceso==true e il sensore era spento, lo accendo (non rischio
		// di creare situazioni di pericolo)
		else if (acceso && !sensori[sensore]) {
			sensori[sensore] = true;
			return true;
		}
		// se acceso==false e il sensore era accesso, verifico anche che i
		// sensori adiacenti siano accesi
		// se sono accesi allora posso spegnerlo
		else if (!acceso && sensori[sensore] && sensori[sensoresuccessivo] && sensori[sensoreprecedente]) {
			sensori[sensore] = false;
			return true;
		} else
			// non posso spegnerlo
			return false;
	}

	
	//@ requires sensore>=0 && sensore<4;
	//@ ensures sensori[sensore]==true==>\result==true;
	//@ ensures sensori[sensore]==false==>\result==false;
	
	public boolean acceso(int sensore) {
		if (sensori[sensore])
			return true;
		else
			return false;
	}

	
	//@ requires true;
	//@ ensures \result==false;
	public boolean pericolo() {
		// (se il sensore  spento && (sensore+1 || sensore-1)  spento)
		// allora siamo in una situazione di pericolo
		// che dall'implementazione di setSensore non dovrebbe mai verificarsi
		if ((!sensori[0] && (!sensori[1] || !sensori[3]))
				|| (!sensori[1] && (!sensori[2] || !sensori[0]))
				|| (!sensori[2] && (!sensori[3] || !sensori[1]))
				|| (!sensori[3] && (!sensori[0] || !sensori[2])))
			return true;
		else
			return false;
	}
}
