package Allarme;

public class Allarme {
	boolean[] sensori;

	public Allarme() {
		sensori = new boolean[4];
		for (int i = 0; i < 4; i++)
			sensori[i] = true;
	}

	public boolean setSensore(int sensore, boolean acceso) {
		// mi serve per sapere se posso spegnere il sensore
		int sensoreprecedente, sensoresuccessivo;
		if (sensore == 0)
			sensoreprecedente = 3;
		else
			sensoreprecedente = sensore - 1;

		if (sensore == 3)
			sensoresuccessivo = 0;
		else
			sensoresuccessivo = sensore + 1;

		// controllo che il parametro sensore sia corretto
		if (sensore >= 0 && sensore < 4) {
			// se accesso==true e il sensore  gi acceso
			// oppure se accesso==false e il sensore  gi spento
			// non fare nulla
			if ((acceso && sensori[sensore]) || (!acceso && !sensori[sensore]))
				return false;

			// se acceso==true e il sensore era spento, lo accendo (non rischio
			// di creare situazioni di pericolo)
			else if (acceso && !sensori[sensore]) {
				sensori[sensore] = true;
				return true;
			}
			// se acceso==false e il sensore era accesso, verifico anche che i
			// sensori adiacenti siano accesi
			// se sono accesi allora posso spegnerlo
			else if (!acceso && sensori[sensore] && sensori[sensoresuccessivo]
					&& sensori[sensoreprecedente]) {
				sensori[sensore] = false;
				return true;
			} else
				// non posso spegnerlo
				return false;
		} else
			// se il parametro sensore non  corretto --> return false
			return false;
	}

	public boolean acceso(int sensore) {
		if (sensore >= 0 && sensore < 4 && sensori[sensore])
			return true;
		else
			return false;
	}

	public boolean pericolo() {
		// (se il sensore  spento && (sensore+1 || sensore-1)  spento)
		// allora siamo in una situazione di pericolo
		// che dall'implementazione di setSensore non dovrebbe mai verificarsi
		if ((!sensori[0] && (!sensori[1] || !sensori[3]))
				|| (!sensori[1] && (!sensori[2] || !sensori[0]))
				|| (!sensori[2] && (!sensori[3] || !sensori[1]))
				|| (!sensori[3] && (!sensori[0] || !sensori[2])))
			return true;
		else
			return false;
	}
}
