import nz.ac.waikato.modeljunit.Action;
import nz.ac.waikato.modeljunit.FsmModel;

//OFFLINE testing (con l'interfaccia): Usando il tool come interfaccia grafica possiamo esplorare il modello e generare le tracce offline.

public class SensoriFSM implements FsmModel {

	boolean[] sensori;

	public SensoriFSM() {
		// La EFSM parte dallo stato iniziale
		reset(true);
	}

	// Ritorna lo stato corrente della EFSM
	@Override
	public Object getState() {
		return "S0: " + sensori[0] + "S1: " + sensori[1] + "S2: " + sensori[2]
				+ "S3: " + sensori[3];
	}

	// Resetta la EFSM allo stato inziale
	@Override
	public void reset(boolean arg0) {
		sensori = new boolean[] { true, true, true, true };
	}

	// I metodi Action definiscono le transizioni della EFSM.
	// I metodi Guard abilitano/disabilitano le Action con dei controlli.

	
	//Spegni
	
	
	@Action
	public void spegniS0() {
		sensori[0] = false; //spengo
	}

	public boolean spegniS0Guard() {
		return sensori[3] && sensori[1] && sensori[0]; //precendente sensore acceso e successivo acceso, il sensore attuale acceso per spegnerlo
	}	
	
	@Action
	public void spegniS1() {
		sensori[1] = false;
	}

	public boolean spegniS1Guard() {
		return sensori[0] && sensori[2] && sensori[1];
	}

	@Action
	public void spegniS2() {
		sensori[2] = false;
	}

	public boolean spegniS2Guard() {
		return sensori[1] && sensori[3] && sensori[2];
	}
	
	@Action
	public void spegniS3() {
		sensori[3] = false;
	}

	public boolean spegniS3Guard() {
		return sensori[2] && sensori[0] && sensori[3];
	}
	
	
	//Accendi
	
	
	@Action
	public void accendiS0() {
		sensori[0] = true;  //accendo
	}
	
	public boolean accendiS0Guard() {
		return sensori[0]!=true; //il sensore attuale spento per accenderlo
	}

	@Action
	public void accendiS1() {
		sensori[1] = true;
	}
	
	public boolean accendiS1Guard() {
		return sensori[1]!=true;
	}

	@Action
	public void accendiS2() {
		sensori[2] = true;
	}
	
	public boolean accendiS2Guard() {
		return sensori[2]!=true;
	}
	
	@Action
	public void accendiS3() {
		sensori[3] = true;
	}
	
	public boolean accendiS3Guard() {
		return sensori[3]!=true;
	}

	
	
	
	
	
	
	

}