
public class Allarme {
	
	// Numero di sensori
	private static final int N = 4;
	
	// Array di boolean che rappresenta i sensori, true se il sensore 
	// acceso, false se il sensore  spento	
	private boolean[] sensori;
	
	// Costruttore della classe Allarme
	public Allarme()
	{
		// Creo il vettore di sensori
		sensori = new boolean[N];
				
		// inizializzo ogni sensore a true (acceso)
		for(int i=0;i<N;i++)
		   sensori[i] = true;
	}
	
	public boolean setSensore(int sensore,boolean acceso)
	{
		//Se l'indice sensore non  valido (<0 oppure >=N), se il sensore adiacente  spento, se il sensore si trova gi nello stato acceso e 
		//vogliamo accenderlo, oppure  spento e vogliamo spegnerlo allora ritorniamo false
		//N.B. fare sensore+N-1  come fare -1 nelle operazioni in modulo
		if(sensore<0 || sensore>=N || sensori[(sensore+N-1)%N]==false || sensori[(sensore+1)%N]==false || acceso==sensori[sensore])
		{
			return false;
		}			
		else
		{
			//possiamo accendere/spegnere il sensore e ritorniamo true
			sensori[sensore]=acceso;
			return true;
		}
			
	}
	
	//Restituisce true se e solo se il sensore con numero sensore esiste ed  acceso
	public boolean acceso(int sensore)
	{
		return sensore>=0 && sensore<N && sensori[sensore];		
	}
	
	
	//Restituisce true se due sensori adiacenti sono spenti
	public boolean pericolo()
	{
		
		return (!sensori[0] && !sensori[1]) || (!sensori[1] && !sensori[2]) || (!sensori[2] && !sensori[3]) || (!sensori[3] && !sensori[0]);
	}
	
	

}
