public class Allarme {
	
	// Numero di sensori
	private /*@ spec_public @*/ static final int N = 4;
	
	// Array di boolean che rappresenta i sensori, true se il sensore 
	// acceso, false se il sensore  spento	
	private /*@ spec_public @*/ boolean[] sensori;
	
	//Sensori  sempre diverso da null
	//@ public invariant sensori != null;
	
	
	//Esiste sempre almeno un sensore acceso
	//@ public invariant (\exists int i;0 <= i && i < 4;sensori[i]);
	
	
	// Costruttore della classe Allarme
	//@ensures (\forall int i ; i >= 0 && i < N ; sensori[i] == true);
	public Allarme()
	{
		
	
		
		
		// Creo il vettore di sensori
		sensori = new boolean[N];
				
		// inizializzo ogni sensore a true (acceso)
		for(int i=0;i<N;i++)
		   sensori[i] = true;
		
		//Violo ensures (\forall int i ; i >= 0 && i < N ; sensori[i] == true);
		//sensori[0] = false;
		
		//violo invariant (\exists int i;0 <= i && i < sensori.length;sensori[i]==true);
		/*
		for(int i=0;i<N;i++)
			   sensori[i] = false;*/
			   
		//violo invariant sensori != null
		//sensori=null; 
	    
		
	}
	
	
	//N.B Per comodit lascio anche gli if di controllo dentro i metodi 
	//(anche se non pi necessarie, visto che adesso sono sostituite dalle precondizioni) 
	//per poter eseguire le violazioni di precondizioni senza generare eccezioni Java.
	
	//@ requires sensore>=0 && sensore<N && sensori[(sensore+N-1)%N]==true && sensori[(sensore+1)%N]==true && acceso!=sensori[sensore];
	//@ensures \result == true;
	//@ensures sensori[sensore]!= \old(sensori[sensore]);
	//@ensures sensori[sensore]==acceso;
	public boolean setSensore(int sensore,boolean acceso)
	{
		//Se l'indice sensore non  valido (<0 oppure >=N), se il sensore adiacente  spento, se il sensore si trova gi nello stato acceso e 
		//vogliamo accenderlo, oppure  spento e vogliamo spegnerlo allora ritorniamo false
		//N.B. fare sensore+N-1  come fare -1 nelle operazioni in modulo
		if(sensore<0 || sensore>=N || sensori[(sensore+N-1)%N]==false || sensori[(sensore+1)%N]==false || acceso==sensori[sensore])
		{
			return false;
		}			
		else
		{
			//possiamo accendere/spegnere il sensore e ritorniamo true
			sensori[sensore]=acceso;
			
			//Violo ensures sensori[sensore]!= \old(sensori[sensore]) e ensures sensori[sensore]!= \old(sensori[sensore];
			//sensori[sensore]=!acceso;
			
			return true;
			
			//Violo ensures \result == true;
			//return false;
			
			
			
		}
			
	}
	
	//Restituisce true se e solo se il sensore con numero sensore esiste ed  acceso
	//@ requires sensore>=0 && sensore<N;
	//@ensures \result ==> (sensore>=0 && sensore<N && sensori[sensore]);
	public boolean acceso(int sensore)
	{
		return sensore>=0 && sensore<N && sensori[sensore];	
		//Violo ensures \result ==> (sensore>=0 && sensore<N && sensori[sensore]);
		//return true;
	}
	
	
	//Restituisce true se due sensori adiacenti sono spenti
	//@ensures \result ==> (\forall int i; i >= 0 && i < N; !sensori[i] && !sensori[(i+1)%N]);
	public boolean pericolo()
	{
		
		return (!sensori[0] && !sensori[1]) || (!sensori[1] && !sensori[2]) || (!sensori[2] && !sensori[3]) || (!sensori[3] && !sensori[0]);
		//Violo ensures \result ==> (\forall int i; i >= 0 && i < N; !sensori[i] && !sensori[(i+1)%N]);
		//return true;
		
	}
	
	

}
