package fsm;

import nz.ac.waikato.modeljunit.FsmModel;
import nz.ac.waikato.modeljunit.Action;

public class Allarme implements FsmModel {

	boolean[] s; //vettori di boolean rappresenta i sensori
	public int n = 4;

	public Allarme() {
		s = new boolean[n];
		for (int i = 0; i < n; i++) {
			s[i] = true;
		}
	}

	@Override
	public Object getState() { 	//visualizzo lo stato
		return "S0: " + s[0] + " - S1: " + s[1] + " - S2: " + s[2] + " - S3: "
				+ s[3];
	}

	@Override
	public void reset(boolean arg0) {  //metodo di reset che porta allo stato iniziale
		s = new boolean[n];
		for (int i = 0; i < n; i++) {
			s[i] = true;
		}
	}

	
	@Action
	public void accendit0() {
		s[0]=true; //metodo che accende il sensore
	}

	@Action
	public void spegnit0() {
		s[0]=false; //metodo che spegne il sensore
	}
	
	//Guardia che controlla i sensori adiacenti per vedere se  possibile spegnere il sensore
	public boolean spegnit0Guard(){
		return s[1]==true && s[3]==true;
	}

	@Action
	public void accendit1() {
		s[1]=true;  //metodo che accende il sensore
	}
	

	@Action
	public void spegnit1() {
		s[1]=false;  //metodo che spegne il sensore
	}
	
	//Guardia che controlla i sensori adiacenti per vedere se  possibile spegnere il sensore
	public boolean spegnit1Guard(){
		return s[0]==true && s[2]==true;
	}

	@Action
	public void accendit2() {
		s[2]=true;  //metodo che accende il sensore
	}

	@Action
	public void spegnit2() {
		s[2]=false;  //metodo che spegne il sensore
	} 
	
	//Guardia che controlla i sensori adiacenti per vedere se  possibile spegnere il sensore
	public boolean spegnit2Guard(){
		return s[1]==true && s[3]==true;
	}

	@Action
	public void accendit3() {
		s[3]=true;  //metodo che accende il sensore
	}
	

	@Action
	public void spegnit3() {
		s[3]=false;   //metodo che spegne il sensore
	}
	
	//Guardia che controlla i sensori adiacenti per vedere se  possibile spegnere il sensore
	public boolean spegnit3Guard(){
		return s[0]==true && s[2]==true;
	}

}
