public class Allarme {

	private /*@ spec_public @*/  boolean[] s;
	private /*@ spec_public @*/  int n = 4;
	
	//s non deve essere mai nullo
	//@ public invariant s!=null;
	//n dev'essere sempre maggiore di 0
	//@ public invariant n>0;

	//mi assicuro che la lunghezza del vettore sia uguale a n
	//@ ensures s.length==n;
	//tutti i sensori devono essere inizializzati a true
	//@ ensures (\forall int i; i>=0 && i<n; s[i]==true);
	//@ diverges true;
	public Allarme() {
		s = new boolean[n];
		
		//s=new boolean[n+1]; //viola ensures s.length==n;
		//s=null; //viola public invariant s!=null;
		//n=-1; //viola public invariant n>0;
		int i = 0;
		//@ loop_invariant i<=n;
		while (i < n) {
			s[i] = true; //inizializzo sensori a true
			i++;
		}
		s[0]=false; //viola ensures (\forall int i; i>=0 && i<n; s[i]==true);
	}

	//il snumero che identifica il sensore deve esserev  valido
	//@requires !(sensore < 0 || sensore >= n || acceso == s[sensore]);
	//se i sensori adiacenti  non sono spenti allora accenod il sensore 
	//@ensures !((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> s[sensore]==acceso;
	//se i sensori adiacenti  non sono spenti allora il risultato  true
	//@ensures !((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> \result==true;
	//se i sensori adiacenti  sono spenti allora ritorno false 
	//@ensures (sensore < 0 || sensore >= n || acceso == s[sensore]) || ((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> \result==false;
	public boolean setSensore(int sensore, boolean acceso) {
		
		if (sensore < 0 || sensore >= n || acceso == s[sensore]) // indice non valido
			return false;
		else if ((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) {
			return false;
			//return true; //viola ensures (sensore < 0 || sensore >= n || acceso == s[sensore]) || ((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> \result==false;
		}
		else{
			s[sensore] = acceso;
			return true;
			//return false; //viola ensures !((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> s[sensore]==acceso;
			// ensures !((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) ==> \result==true;
		}

	}

	//il snumero che identifica il sensore deve esserev  valido
	//@requires !(sensore < 0 || sensore >= n || s[sensore] == false);
	//se  valido allora ritorno true
	//@ensures !(sensore < 0 || sensore >= n || s[sensore] == false) ==> \result==true;
	public boolean acceso(int sensore) {
		if (sensore < 0 || sensore >= n || s[sensore] == false)
			return false;
			//return true; //violo ensures (sensore < 0 || sensore >= n || s[sensore] == false) ==> \result==false;
			else
				return true;
				//return false; //violo ensures !(sensore < 0 || sensore >= n || s[sensore] == false) ==> \result==true;
		}

	//@ensures ((s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false)) ==> \result==true;
	//@ensures !((s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false)) ==> \result==false;
	public boolean pericolo() {	
		if( (s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false))
			return true;
		//return false; //violo ensures ((s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false)) ==> \result==true;
		else
			return false;
		//return true; //violo ensures !((s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false)) ==> \result==false;
	}

}
